#include "skeleton.h"
#include "idux_config.h"
#ifndef APPNAME
#error "APPNAME not defined!"
#endif
#ifndef DEFAULTPATH
#error "DEFAULTPATH not defined!"
#endif
#define STYLE FL_PLASTIC_DOWN_BOX


int main (int argc, char *argv[])
{
  GUI gui;
  gui.myname = argv[0];
  string temp = "";
  temp = APPNAME;
  temp.append(" Setup");
  gui.load_gui(temp.c_str()); 
  gui.draw_buttons();
  gui.draw_intro();
  gui.set_wizard_widgets();
  return Fl::run();
}

void GUI::load_gui(const char *title)
{

  window = new Fl_Window (500, 350, title);

  step_title = new Fl_Box(0,0, 500, 24);
  step_title->labeltype(FL_EMBOSSED_LABEL);
  step_description = new Fl_Box(0,25, 500, 24);
  step_description->labelsize(12);
  step_description->labelfont(FL_TIMES);
  wiz = new Fl_Wizard (0, 47, 499, 280);
  wiz->box (FL_PLASTIC_DOWN_BOX);
  window->show ();
}

void GUI::draw_intro()
{
  current_step = INTRO;
  string temp,temp2,temp3 = "";
  temp.append(opt.AppName);
  temp.append(" Setup");
  set_step_title(temp.c_str(), "");


  temp2.append(opt.AppName);
  temp2.append(" ");
#ifdef APPVER
  temp2.append(opt.AppVer);
#endif
#ifdef APPDESCRIPTION
  temp3.append(opt.AppDesc);
#endif

  Fl_Group *group = new Fl_Group(0,47,499,280);
  group->begin();
  new Fl_Box(0, 47, 499, 25, temp2.c_str());
  new Fl_Box(0, 72, 499, 25, temp3.c_str());

  Fl_Pixmap *pixmap = new Fl_Pixmap(logo_xpm);
  Fl_Box *piclabel = new Fl_Box(0, 160, 499, 25);
  piclabel->image(pixmap);

#ifdef COPYRIGHT
  new Fl_Box(0, 245, 499, 25, (opt.CopyRight).c_str());
#endif

  new Fl_Box(0, 280, 499, 25, "This application will be installed in your computer.");

  new Fl_Box(0, 295, 499, 25, "Press next to continue or cancel to exit.");
  group->end();

  wiz->add
  (group);
}

void GUI::set_wizard_widgets()
{
#ifdef WITHLICENSE
  license_group = new Fl_Group(0,47,499,280);
  license_group->begin();
  new Fl_Box(0, 47, 499, 25, "Please read the following license agreement.");
  new Fl_Box(0, 63, 499, 25, "You must accept before continuing with the installation.");

  Fl_Text_Buffer *buffer = new Fl_Text_Buffer((opt.LicenseString).length());

  licensebuff = new Fl_Text_Display(12, 90, 476, 190);
  licensebuff->buffer(buffer);
  licensebuff->box(STYLE);
  licensebuff->insert((opt.LicenseString).c_str());
  accept_button = new Fl_Round_Button(5, 292, 100, 20, "I Accept");
  accept_button->type(FL_RADIO_BUTTON);
  accept_button->box(STYLE);
  reject_button = new Fl_Round_Button(107, 292, 170, 20, "I Do Not Accept");
  reject_button->type(FL_RADIO_BUTTON);
  reject_button->box(STYLE);
  reject_button->setonly();
  accept_button->callback(accept_cb, this);
  reject_button->callback(reject_cb, this);
  reject_button->setonly();
  license_group->end();
#endif
  /////////////////////////////////////////////////
  path_group = new Fl_Group(0,47,499,280);
  path_group->begin();
  path_input = new Fl_Input(50, 70, 400, 25, "Path:");
  path_input->value((opt.DefaultPath).c_str());
  path_input->box(STYLE);
  browse_button = new Fl_Button(50, 95, 400, 25, "Browse");
  browse_button->box(STYLE);
  browse_button->callback(browse, this);
  path_group->end();

  /////////////////////////////////////////////////////
  check_group = new Fl_Group(0,47,499,280);
  check_group->begin();
  check_label = new Fl_Box(0, 100, 499, 25, "");
  check_group->end();
  ////////////////////////////////////////////////////
  install_group = new Fl_Group(0,47,499,280);
  install_group->begin();
  gauge = new Fl_Progress(50,280/2, 400, 30);
  gauge->box(STYLE);
  install_group->end();
  ///////////////////////////////////////////////////
  post_group = new Fl_Group(0,47,499,280);
#ifdef WITHLICENSE
  wiz->add
  (license_group);
#endif
  wiz->add
  (path_group);
  wiz->add
  (check_group);
  wiz->add
  (install_group);
  wiz->add
  (post_group);
}

void GUI::draw_buttons()
{
  Fl_Group *group = new Fl_Group(0, 310, 500, 40);
  group->begin();
  back = new Fl_Button(280, 315, 70, 25, "< Back");
  back->box(STYLE);
  next = new Fl_Button(350, 315, 70, 25, "Next >");
  next->box(STYLE);
  cancel = new Fl_Button(428, 315, 70, 25, "Cancel");
  cancel->box(STYLE);
  group->end();
  next->callback(next_callback, this);
  back->callback(back_callback, this);
  cancel->callback(cancel_callback, this);
  window->add
  (group);
}

options::~options()
{
  //delete []files;
}
//Loads the values from the idux_config file into the options struct.
options::options()
{
  AppName = APPNAME;
  if (DEFAULTPATH == "DEFAULT")
    DefaultPath = "/usr/share";
  else
    DefaultPath = DEFAULTPATH;
  nfiles = NFILES;
  files = new string[NFILES*3];
  files = idux_files;

  LicenseString = "";
  AppVer = "";
  AppDesc = "";
  CopyRight = "";
#ifdef APPVER
  AppVer = APPVER;
#endif
#ifdef APPDESCRIPTION
  AppDesc = APPDESCRIPTION;
#endif
#ifdef COPYRIGHT
  CopyRight = COPYRIGHT;
#endif

#ifdef WITHLICENSE
  LicenseString = LICENSE_STRING;
#endif

  InstallPath = DefaultPath + "/" + AppName + "/";

}

void GUI::install_files()
{
  /*The crappy code in this function will be re-written*/
  //Takes care of installation
  /*TODO: I hate system calls*/
  string temp;
  gauge->maximum(opt.nfiles);
  temp = "mkdir -vp ";
  temp.append(opt.InstallPath);

  if (system(temp.c_str()))
    {
      wiz->prev();
      wiz->prev();
      current_step--;
      current_step--;
      fl_alert("mkdir() failed!\nMake sure you have write permissions to specified install path.\nAnd that the directory doesn't already exist.");
      next->activate();
      back->activate();
      cancel->activate();
      return;
    }

#ifdef DIRS
  temp = "cd ";
  temp.append(opt.InstallPath);
  temp.append(" && ");
  temp.append("mkdir -vp ");
  temp.append(DIRS);
  system(temp.c_str());
#endif

  gauge->label("Installing...");
  
  pthread_t thread;
  pthread_create(&thread, NULL, extract_zip, (void *)myname.c_str());

  while(!DONE_EXTRACTING) gauge->value(filen);
  
    gauge->value(filen);
    gauge->label("Done. Press next to finish."); 
    next->activate();
}

void GUI::next_callback(Fl_Widget *not_used)
{
  wiz->next();
  if (current_step != POST)
    current_step++;
  if (current_step == LICENSE && (opt.LicenseString).length() < 1)
    current_step++;
  switch(current_step)
    {
    case INTRO:
      intro();
      break;
    case LICENSE:
      license();
      break;
    case PATH:
      path();
      break;
    case CHECK:
      check();
      break;
    case INSTALL:
      install();
      break;
    case POST:
      post();
      break;
    }
}

void GUI::back_callback(Fl_Widget *not_used)
{
  wiz->prev();
  if (current_step != INTRO)
    current_step--;
  if (current_step == LICENSE && (opt.LicenseString).length() < 1)
    current_step--;
  switch(current_step)
    {
    case INTRO:
      intro();
      break;
    case LICENSE:
      license();
      break;
    case PATH:
      path();
      break;
    case CHECK:
      check();
      break;
    case INSTALL:
      install();
      break;
    case POST:
      post();
      break;
    }
}

void GUI::cancel_callback(Fl_Widget *not_used)
{
  exit(0);
}

void GUI::set_step_title(const char* title, const char* description)
{
  step_title->label(title);
  step_description->label(description);
}

void GUI::license()
{
  set_step_title("License Agreement", "Please read before continuing.");
  next->deactivate();
  reject_button->setonly();
}

void GUI::path()
{
  set_step_title("Select Installation Path", "Where to install?");
  next->label("Next >");
}

void GUI::check()
{
  /*Set installation path*/
  opt.DefaultPath = path_input->value();
  opt.InstallPath = opt.DefaultPath + "/" + opt.AppName;
  set_step_title("Ready to Install", "Press 'Install' to begin installation.");
  check_label->label(string(opt.AppName + " will be installed in: " + opt.InstallPath).c_str());
  next->label("Install");
}

void GUI::install()
{
  set_step_title("Installing...", "Please Wait");
  next->label("Next >");
  next->deactivate();
  back->deactivate();
  cancel->deactivate();
  install_files();
}

void GUI::post()
{
  set_step_title("Installation Complete", "Press 'Finish' to exit.");
  next->deactivate();
  back->deactivate();
  cancel->activate();
  cancel->label("Finish");
}

void GUI::intro()
{
  next->activate();
  current_step = INTRO;
  string temp,temp2,temp3 = "";
  temp.append(opt.AppName);
  temp.append(" Setup");
  set_step_title(temp.c_str(), "");
}

void GUI::accept_cb(Fl_Widget *notused)
{
  next->activate();
}

void GUI::reject_cb(Fl_Widget *notused)
{
  next->deactivate();
}

void GUI::browse(Fl_Widget *notused)
{
  Fl_File_Chooser *browser = new Fl_File_Chooser(".", "", Fl_File_Chooser::DIRECTORY, "Select Path...");
  browser->preview(0);
  browser->callback(set_filename, this);
  browser->show();
}

void GUI::set_filename(Fl_File_Chooser *browser)
{
path_input->static_value(browser->value());
}


void *extract_zip(void *temp)
{
  const char *filename = (const char*)(temp);
 DONE_EXTRACTING = false;
 filen = 0;

  ZipFile zip;
  try
    {
      zip = ZipFile::openEmbeddedZipFile(filename);
    }
  catch(...)
    {
      cout << "Append the zip!\n";
    }
  if (!zip.isValid())
    {
      fl_alert("Invalid archive!");
      return NULL;
    }
  ConstEntryPointer current;
  string current_file;
  int x = 0;

 
  string temp_path;
  try
    {
      for (x = 0; x < opt.nfiles * 3; x = x + 3)
        {
          current_file = opt.files[x];

          file = current_file;
          filen = x;

          temp_path = opt.InstallPath + "/" + current_file;
          current = zip.getEntry(current_file);
          auto_ptr< istream > is( zip.getInputStream(current) );

          ofstream ofs(temp_path.c_str(), ios::out | ios::binary);
          ofs << is->rdbuf() ;
          ofs.close() ;
          if (opt.files[x + 2] == "binary")
            {
              system(string("chmod +x " + temp_path).c_str());
              system(string("ln -s " + temp_path + " /usr/local/bin/" + opt.AppName).c_str());
            }
        }
    }
  catch( exception &excp )
    {
      cerr << "Exception caught:" << endl;
      cerr << excp.what() << endl;
    }

  zip.close();
  DONE_EXTRACTING = true;
  return NULL;
}
